package dbtypes

import (
	"encoding/json"

	"git.andr3h3nriqu3s.com/andr3/fyp/logic/db"
)

type LayerType int

const (
	LAYER_INPUT        LayerType = 1
	LAYER_DENSE                  = 2
	LAYER_FLATTEN                = 3
	LAYER_SIMPLE_BLOCK           = 4
)

type Layer struct {
	Id           string    `db:"mdl.id"`
	DefinitionId string    `db:"mdl.def_id"`
	LayerOrder   string    `db:"mdl.layer_order"`
	LayerType    LayerType `db:"mdl.layer_type"`
	Shape        string    `db:"mdl.shape"`
	ExpType      string    `db:"mdl.exp_type"`
}

func ShapeToString(args ...int) string {
	text, err := json.Marshal(args)
	if err != nil {
		panic("Could not generate Shape")
	}
	return string(text)
}

func StringToShape(str string) (shape []int64) {
	err := json.Unmarshal([]byte(str), &shape)
	if err != nil {
		panic("Could not parse Shape")
	}
	return
}

func (l Layer) GetShape() []int64 {
	return StringToShape(l.Shape)
}

func GetLayer(db db.Db, layer_id string) (layer Layer, err error) {
	err = GetDBOnce(db, &layer, "model_definition_layer as mdl where mdl.id=$1", layer_id)
	return
}
